<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:psmi="http://www.CraneSoftwrights.com/resources/psmi"
                xmlns="http://www.w3.org/1999/XSL/Format"
                version="1.0">
<!--

 $Id: example.xsl,v 1.6 2008/08/05 00:39:55 gkholman Exp $

 This stylesheet puts all of the document content into a single 
 fo:page-sequence and relies on the psmi:page-sequence construct to break up
 the result into as many page sequences as is needed for the landscape table 
 content.

 This means that subsections do *not* trigger page sequences on their own and
 they and their titles are flowed with the rest of the content.

-->
<xsl:output indent="yes"/>

<xsl:template match="/">
  <root font-family="Times" font-size="20pt">

    <layout-master-set>
      <simple-page-master master-name="frame"
        page-height="297mm" page-width="210mm"
        margin-top="15mm" margin-bottom="15mm"
        margin-left="15mm" margin-right="15mm">
        <region-body region-name="frame-body"
                     margin-top="15mm" margin-bottom="15mm"/>
        <region-before region-name="frame-before" extent="15mm"/>
        <region-after region-name="frame-after" extent="15mm"/>
      </simple-page-master>
      <simple-page-master master-name="frame-landbody"
        page-height="210mm" page-width="297mm"
        margin-top="15mm" margin-bottom="15mm"
        margin-left="15mm" margin-right="15mm">
        <region-body region-name="frame-body" 
                     reference-orientation="90"
                     margin-top="15mm" margin-bottom="15mm"/>
        <region-before region-name="frame-before" extent="15mm"/>
        <region-after region-name="frame-after" extent="15mm"/>
      </simple-page-master>
    </layout-master-set>

    <page-sequence master-reference="frame" force-page-count="end-on-even"
                   initial-page-number="13">
      <title>A test sequence</title>
      <static-content flow-name="frame-before">
        <block text-align="center">Test header: page <page-number/></block>
      </static-content>
      <static-content flow-name="frame-after">
        <block text-align="center">Test footer</block>
      </static-content>
      <flow flow-name="frame-body">
        <xsl:apply-templates/>
      </flow>
    </page-sequence>
  </root>
</xsl:template>

<xsl:template match="title">
  <block font-size="2em"><xsl:apply-templates/></block>
</xsl:template>

<xsl:template match="para">
  <block><xsl:apply-templates/></block>
</xsl:template>

<!--the presence of title and static-content in the following is only for
    testing purposes to ensure any such constructs take precedence over
    the parent's such constructs
-->
<xsl:template match="tbl[@orient='land']">
  <psmi:page-sequence master-reference="frame-landbody">
    <title>Landscape content</title>
    <flow flow-name="frame-body">
      <xsl:call-template name="do-a-table"/>
    </flow>
  </psmi:page-sequence>
</xsl:template>

<xsl:template match="tbl" name="do-a-table">
  <table>
    <table-body>
      <xsl:apply-templates/>
    </table-body>
  </table>
</xsl:template>

<xsl:template match="row">
  <table-row>
    <xsl:apply-templates/>
  </table-row>
</xsl:template>

<xsl:template match="col">
  <table-cell border="solid">
    <xsl:apply-templates/>
  </table-cell>
</xsl:template>

</xsl:stylesheet>
